1000 ' HEAPSORT demonstration program by Ron A. Zajac
1010 '
1020 CLEAR 1000: DEFINT A-V: DEFSTR W-Z: DIM A(15)
1030 '
1040 GOSUB 1400 ' Load array, initialize PRINT USING strings
1050 '
1060 ZZ="Unsorted": GOSUB 1290 ' Display unsorted heap
1070 FOR I=INT(N/2) TO 1 STEP -1: GOSUB 1180: NEXT I
1080 ZZ="Heaped": GOSUB 1290 ' Displ. heap after one pass
1090 '
1100 ZZ="Sorted": I=1: C=N-1
1110 '
1120 FOR M=C TO 1 STEP -1
1130 B=A(1): A(1)=A(M+1): A(M+1)=B
1140 N=M: GOSUB 1180: GOSUB 1290 ' Display after each pass
1150 NEXT M
1160 END
1170 '
1180 K=I
1190 J=2*K
1200 IF J>N THEN RETURN
1210 IF J<N THEN IF A(J+1)>A(J) THEN J=J+1
1220 IF A(K)<=A(J) THEN B=A(K): A(K)=A(J): A(J)=B: K=J ELSE RETURN
1230 GOTO 1190
1240 '
1250 '  **************************************************
1260 '
1270 '  This subroutine prints the tree in a graphic form.
1280 '
1290 PRINT CHR$(28)
1300 IF M<2 THEN PRINT USING W0;ZZ,A(1) ELSE PRINT USING WT;M,A(1)
1310 PRINT X: PRINT USING W5;A(2),A(3)
1320 PRINT Y: PRINT USING W8;A(4),A(5),A(6),A(7): PRINT Z
1330 PRINT USING WA;A(8),A(9),A(10),A(11),A(12),A(13),A(14),A(15)
1340 PRINT: PRINT: LINE INPUT "ENTER to continue ==>";X0
1350 RETURN
1360 '
1370 '  This subroutine initializes the PRINT USING strings
1380 '  and loads the array of integer values to be sorted.
1390 '
1400 W0="%      %                 ##"
1410 WT="Sort Proc, M=##:         ##"
1420 W1="                       /    \"
1430 W2="                     /        \"
1440 W3="                   /            \"
1450 W4="                 /                \"
1460 W5="               ##                  ##"
1470 W6="              /  \                /  \"
1480 W7="            /      \            /      \"
1490 W8="          ##        ##        ##        ##"
1500 W9="         /  \      /  \      /  \      /  \"
1510 WA="       ##    ##  ##    ##  ##    ##  ##    ##"
1520 '
1530 X=W1+CHR$(13)+W2+CHR$(13)+W3+CHR$(13)+W4
1540 Y=W6+CHR$(13)+W7: Z=W9
1550 M=0: READ N: FOR A=1 TO N: READ A(A): NEXT A
1560 CLS: RETURN
1570 '
1580 DATA 15
1590 DATA 11,4,14,8,18,15,6,20,9,5,3,16,12,17,2
